VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ListBox Examples"
   ClientHeight    =   5784
   ClientLeft      =   4452
   ClientTop       =   1032
   ClientWidth     =   6396
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5784
   ScaleWidth      =   6396
   Begin VB.Frame Frame3 
      Caption         =   "Using Tab-stops to Align Columns"
      Height          =   1935
      Left            =   120
      TabIndex        =   11
      Top             =   3720
      Width           =   6135
      Begin VB.ListBox lstTabs 
         Height          =   1392
         Left            =   120
         Sorted          =   -1  'True
         TabIndex        =   12
         Top             =   360
         Width           =   5895
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "ListBox API Examples"
      Height          =   3495
      Left            =   2760
      TabIndex        =   3
      Top             =   120
      Width           =   3495
      Begin VB.CommandButton cmdList 
         Caption         =   "&Empty"
         Height          =   375
         Index           =   3
         Left            =   2520
         TabIndex        =   13
         Top             =   1800
         Width           =   855
      End
      Begin VB.CommandButton cmdList 
         Caption         =   "&Selected"
         Height          =   375
         Index           =   2
         Left            =   2520
         TabIndex        =   8
         ToolTipText     =   "Get Number of Items Highlighted"
         Top             =   1320
         Width           =   855
      End
      Begin VB.CommandButton cmdList 
         Caption         =   "&Delete"
         Height          =   375
         Index           =   1
         Left            =   2520
         TabIndex        =   7
         ToolTipText     =   "Delete a SINGLE Highlighted Item"
         Top             =   840
         Width           =   855
      End
      Begin VB.CommandButton cmdList 
         Caption         =   "&Clear All"
         Height          =   375
         Index           =   0
         Left            =   2520
         TabIndex        =   6
         ToolTipText     =   "Clear all highlighted items"
         Top             =   360
         Width           =   855
      End
      Begin VB.ListBox lstMulti 
         Height          =   2928
         Left            =   120
         MultiSelect     =   1  'Simple
         Sorted          =   -1  'True
         TabIndex        =   5
         ToolTipText     =   "Multi-Select ListBox. Use SHIFT or CTRL to select multiple items"
         Top             =   360
         Width           =   2295
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Search for a Font Name"
      Height          =   3495
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   2535
      Begin VB.TextBox txtSearch 
         BackColor       =   &H00FFFFFF&
         Height          =   285
         Left            =   120
         TabIndex        =   0
         ToolTipText     =   "Start typing and I will find your string!"
         Top             =   360
         Width           =   2295
      End
      Begin VB.ListBox lstSearch 
         BackColor       =   &H00FFFFFF&
         Height          =   1776
         ItemData        =   "Form1.frx":0000
         Left            =   120
         List            =   "Form1.frx":0007
         Sorted          =   -1  'True
         TabIndex        =   1
         TabStop         =   0   'False
         ToolTipText     =   "Click a font to populate the text box"
         Top             =   720
         Width           =   2295
      End
      Begin VB.Label lblItem1 
         Caption         =   "First Item"
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   3120
         Width           =   2175
      End
      Begin VB.Label lblIndex 
         Caption         =   "Index:"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   2880
         Width           =   2175
      End
      Begin VB.Label lblCount 
         Caption         =   "Items:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   2640
         Width           =   2175
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim bFound As Boolean

'
' Most of this stuff will work for comboboxes and textboxes as well.
' Just use the corresponding CB_ and EM_ constants.
'

'General Messages
Const LB_ERR = -1
Const LB_SETTOPINDEX = &H197  'insure that a particular item is visible
Const LB_GETCOUNT = &H18B     'retrieve the number of items in a list box
Const LB_GETSEL = &H187       'retrieve the selection state of an item
Const LB_ADDSTRING = &H180    'add a string and re-sort a sorted listbox
Const LB_INSERTSTRING = &H181 'add a string but do not re-sort a sorted listbox
Const LB_DELETESTRING = &H182 'delete a single string
Const LB_FINDSTRING = &H18F   'find the first string containing the string specified
Const LB_FINDSTRINGEXACT = &H1A2 'find the first string that matches the string specified
Const LB_SETTABSTOPS = &H192  'set the tab-stop positions
Const LB_RESETCONTENT = &H184 'remove all items

'Multi-Select Listboxes
Const LB_SETSEL = &H185       'select a string
Const LB_GETSELCOUNT = &H190  'retrieve the total number of selected items

'Single Selection Listboxes
Const LB_SELECTSTRING = &H18C 'find the first string containing the string specified
Const LB_GETCURSEL = &H188    'retrieve the index of the currently selected item
Const LB_SETCURSEL = &H186    'select a string and scroll it into view

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SendMessageArray Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Sub cmdList_Click(Index As Integer)
Dim lReturn As Long

On Error Resume Next
With lstMulti
Select Case Index
    Case 0 'Clear all selected items
        'Set wParam True to select item, Flase to Deselect.
        'lParam is item to select.  -1 = all
        lReturn = SendMessage(.hwnd, LB_SETSEL, False, -1&)
    Case 1 'Delete a SINGLE item
        If SendMessage(.hwnd, LB_GETSELCOUNT, 0&, 0&) = 1 Then
            'wParam is the index,  lParam is always 0.
            lReturn = SendMessage(.hwnd, LB_DELETESTRING, lstMulti.ListIndex, 0&)
        Else
            MsgBox "Select a single item to delete", vbInformation, "Delete Error"
        End If
    Case 2 'Number of items selected
        'wParam and lParam always 0
        lReturn = SendMessage(.hwnd, LB_GETSELCOUNT, 0&, 0&)
        MsgBox Val(lReturn), vbInformation, "Items Selected"
    Case 3 'Empty the listbox
        'wParam and lParam always 0
        lReturn = SendMessage(.hwnd, LB_RESETCONTENT, 0&, 0&)
End Select
End With
End Sub



Private Sub Form_Load()
Dim iItems     As Integer
Dim sItem      As String
Dim i          As Integer
Dim l          As Long
ReDim aTabs(3) As Long
'
' Prefill the listboxes.
'
On Error Resume Next
For i = 0 To Screen.FontCount - 1
    'wParam must be 0, lParam is the address of the string to add.
    l = SendMessage(lstSearch.hwnd, LB_ADDSTRING, 0&, Screen.Fonts(i))
    l = SendMessage(lstMulti.hwnd, LB_ADDSTRING, 0&, Screen.Fonts(i))
Next
'
'Get number of items in listbox.
'wParam and lParam must be 0.
lblCount = "Number of Items:  " & SendMessage(lstSearch.hwnd, LB_GETCOUNT, 0&, 0&)
'
'---------------------------------------------------------------------------------
' Set up a listbox with TAB delimited columns.
' Add the desired tabstops to an array.
'
' NOTE: tabstops are defined in terms of "dialog units". While the
'       GetDialogBaseUnits function combined with a simple calculation
'       can be used to convert between dialog units and pixels, the
'       easiest way to set tabstops where you want is by trial and error.
'
aTabs(0) = 75
aTabs(1) = 150
aTabs(2) = 225
'Clear any existing tabs.
Call SendMessageArray(lstTabs.hwnd, LB_SETTABSTOPS, 0&, 0&)
'Set the tabs.
Call SendMessageArray(lstTabs.hwnd, LB_SETTABSTOPS, 3&, aTabs(0))

' Populate the array. Separate columns with the TAB character.
iItems = Screen.FontCount \ 4
For i = 1 To iItems Step 4
    For l = 0 To 3
        sItem = sItem & Screen.Fonts(i + l) & vbTab
    Next
    Call SendMessage(lstTabs.hwnd, LB_ADDSTRING, 0&, sItem)
    sItem = ""
Next
End Sub


Public Sub AutoFind(txtBox As TextBox, LstBox As ListBox)
Dim sSearch As String
Dim lIndex  As Long
Dim lReturn As Long
'
' NOTE: In order for this to work, the listbox should be sorted.
'
bFound = False
sSearch = txtBox.Text 'Text boxes cannot be passed in the API call.
If Len(sSearch) Then
    '
    ' Search the listbox for the text. Not case sensitive.
    ' The result is the index into the listbox.
    '
    ' Wparam indicates the index to start searching from. -1 = start at top.
    ' lParam is address of the string to search for.
    lIndex = SendMessage(LstBox.hwnd, LB_FINDSTRING, -1, ByVal sSearch)
    '
    ' Scroll the listbox item to the top of the list.
    '
    ' Wparam indicates the item to move to the top.  lParam is always 0.
    lReturn = SendMessage(LstBox.hwnd, LB_SETTOPINDEX, lIndex, 0&)
    '
    ' If the item was moved to the top. highlight it.
    '
    lReturn = SendMessage(LstBox.hwnd, LB_SETCURSEL, lIndex, 0&)
    
   If lIndex <> LB_ERR Then
        bFound = True
   End If
Else
    '
    ' No text was entered. Scroll the listbox to the top of
    ' the list and deselect all items.
    '
    lReturn = SendMessage(LstBox.hwnd, LB_SETTOPINDEX, 0, 0&)
    lReturn = SendMessage(LstBox.hwnd, LB_SETCURSEL, -1, 0&)
End If
End Sub


Private Sub lstSearch_Click()
'
' When the user selects a item, add it to the listbox.
'
txtSearch.Text = lstSearch.Text
'
'wParam and lParam always 0
lblIndex = "Index of Selected Item:  " & SendMessage(lstSearch.hwnd, LB_GETCURSEL, 0&, 0&)

'wParam is index of item whose selection state to determine.  lParam always 0
lblItem1 = "First Item Selected:   " & (SendMessage(lstSearch.hwnd, LB_GETSEL, 0&, 0&) > 0)
End Sub

Private Sub txtSearch_Change()
'
' Look for a listbox item matching the text
' entered so far.
'
Call AutoFind(txtSearch, lstSearch)
End Sub


Private Sub txtSearch_GotFocus()
'
' Set a flag indicating we found the item.
'
'bFound = True
End Sub


Private Sub txtSearch_LostFocus()
'
' If we found a partial match and the user TABs off
' this field, add the item to the textbox.
'
If bFound Then txtSearch = lstSearch.Text
End Sub


